# Custom Event Triggers The Event Trigger service manages the business events and trigger conditions that are defined on [Zuora Business Object Model](http://knowledgecenter.zuora.com/BB_Introducing_Z_Business/D_Zuora_Business_Objects_Relationship) or custom objects. When a Zuora object changes, the trigger conditions defined on the object are evaluated, and if any condition qualifies, a business event will be triggered and turned into a notification. **Note**: Event Triggers operations are only applicable to custom events. ## Create an event trigger - [POST /events/event-triggers](https://developer.zuora.com/v1-api-reference/api/custom-event-triggers/post_eventtrigger.md): When you create an event trigger, you must specify the base object and define the trigger condition. ### Specify the base object Use baseObject field to specify which object to define a trigger on. You can define an event trigger on any of the following objects: * Account * AccountingCode * AccountingPeriod * Amendment * BillingRun * Contact * CreditBalanceAdjustment * CreditMemo * CreditMemoApplication * CreditMemoApplicationItem * CreditMemoItem * CreditMemoPart * DebitMemo * DebitMemoItem * DeliveryAdjustment * Feature * Fulfillment * Fund * Invoice * InvoiceAdjustment * InvoiceItem * InvoiceItemAdjustment * JournalEntry * JournalEntryItem * Order * OrderAction * OrderLineItem * Payment * PaymentApplication * PaymentMethod * PaymentPart * PaymentSchedule * PaymentScheduleItem * Product * ProductFeature * ProductRatePlan * ProductRatePlanCharge * ProductRatePlanChargeTier * RatePlan * RatePlanCharge * RatePlanChargeTier * RatingResult * Refund * RefundApplication * RefundPart * RevenueEvent * RevenueEventItem * RevenueSchedule * RevenueScheduleItem * Subscription * SubscriptionChargeDeliverySchedule * SubscriptionChargePriceInterval * SubscriptionChargePriceIntervalTier * SubscriptionOffer * SubscriptionProductFeature * TaxationItem * UpdaterDetail * Usage * ValidityPeriodSummary In addition to the above Zuora standard objects, you can also use custom objects as base objects for custom events. #### Tenant level base objects and tenant level event triggers Zuora identifies the following base objects and custom objects as the tenant level base objects: * AccountingCode * AccountingPeriod * BillingRun * Feature * JournalEntry * JournalEntryItem * Product * ProductFeature * ProductRatePlan * ProductRatePlanCharge * ProductRatePlanChargeTier Event triggers defined on tenant level base objects are tenant level event triggers. Notifications associated with tenant level events are system notifications. Note: Tenant level event triggers and system notifications are only available in the default profile. ### Define the trigger condition The condition field is a JEXL expression that specifies when to trigger events. The expression can contain fields from the object that the trigger is defined on. Note: The condition cannot contain fields from data source objects that are joined to the object that the trigger is defined on. For example, the following condition causes an event to be triggered whenever an invoice is posted with an amount greater than 1000: changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0 Where: * changeType is a keyword that specifies the type of change that occurred to the Invoice object. For all objects, the supported values of changeType are INSERT, UPDATE, and DELETE. * Invoice.Status is the value of the Invoice object's Status field after the change occurred. * Invoice.Status_old is the value of the Invoice object's Status field before the change occurred. In the above example, the value of baseObject is Invoice. #### Limitations This event trigger has the following limitations: * Base object values for Zuora standard objects are case sensitive. For example, PaymentMethod is correct, and Paymentmethod or paymentmethod is incorrect. * Base object values for custom objects must be lowercase. For example, default__vehicle. * The INSERT change type is not supported on RatePlan base objects. * The INSERT change type is not supported on SubscriptionProductFeature base objects. * When creating custom events, you cannot match fields of the RatePlanCharge object against constant values for the condition field. For example, the following condition will cause errors: RatePlanCharge.ShippingProcessStatus__c == 'Shipping Confirmed', where Shipping Confirmed is a constant value. * Fields on objects are case-sensitive. For example, PaymentMethod.createdbyid can result in errors. The correct format is PaymentMethod.CreatedById. * A condition cannot contain fields from data source objects that are joined to the base object. * Do not create duplicate events because they will be either merged or deleted. Zuora considers events that have the same trigger condition as duplicate events, regardless of event type names. See Custom Events for more information. ## List event triggers - [GET /events/event-triggers](https://developer.zuora.com/v1-api-reference/api/custom-event-triggers/get_eventtriggers.md) ## Retrieve an event trigger - [GET /events/event-triggers/{id}](https://developer.zuora.com/v1-api-reference/api/custom-event-triggers/get_eventtrigger.md) ## Update an event trigger - [PUT /events/event-triggers/{id}](https://developer.zuora.com/v1-api-reference/api/custom-event-triggers/put_eventtrigger.md) ## Delete an event trigger - [DELETE /events/event-triggers/{id}](https://developer.zuora.com/v1-api-reference/api/custom-event-triggers/delete_eventtrigger.md)